package com.iamberry.wechat.face.admin;

import java.util.List;

import com.iamberry.app.tool.des.MD5;
import com.iamberry.wechat.core.entity.admin.AdminChildPermissionErmissions;
import com.iamberry.wechat.core.entity.admin.AdminChildPermissions;
import com.iamberry.wechat.core.entity.admin.AdminLoginDTO;

public interface AdminLoginService {

	/**
	 * 根据用户名、密码查询用户信息
	 * @param dto
	 * @return
	 */
	public Object selectAdminInfoByNameAndPwd(AdminLoginDTO dto) throws Exception;

	/**
	 * 根据二级管理ID，获取此二级管理员所有的权限
	 * @param id
	 * @return
	 */
	public List<AdminChildPermissionErmissions> selectAdminChildHavePermissionById(Integer id);

	/**
	 * 获取管理员的菜单信息
	 * @param id
	 * @param flag 如果为超级管理员使用true，反之false
	 * @return
	 */
	public List<AdminChildPermissions> selectMenusById(Integer id, boolean flag);
}
