package com.iamberry.wechat.face.agent;

import java.util.List;
import java.util.Map;

import com.iamberry.wechat.core.entity.agent.AgentMemberDto;
import com.iamberry.wechat.core.entity.member.Member;

/**
 * 微代理会员中心	service
 * 2016年4月20日
 * @author 穆再兴
 *
 */
public interface AgentMemberService {
	/**
	 * 根据openid获取该用户 各种状态的订单数量
	 * 2016年4月20日
	 * @author 穆再兴
	 * @param openid
	 * @return
	 */
	public List<Map<String, Integer>> getMyOrderStatusCount(String openid);
	/**
	 * 获取当前用户微代理信息
	 * 2016年4月20日
	 * @author 穆再兴
	 * @return
	 */
	public AgentMemberDto getAgentMemberInfo(String openid);
	
	/**
	 * 查询当前用户<微代理>的待返还金额 <包括下线将返的100 及下线的下线将返还的40>
	 * 2016年5月19日
	 * @author mzx
	 * @return
	 */
	public Integer getWillIncomeByOpenId(String openid);
	
	/**
	 * 根据openid 获取用户信息、各种状态订单的数量、待返金额 
	 * @param member
	 * @return
	 */
	public AgentMemberDto getMemberInfo(Member member);
}
