package com.iamberry.wechat.face.home;

import java.util.List;

import com.iamberry.wechat.core.entity.banner.ActionBannerImage;
import com.iamberry.wechat.core.entity.member.Member;

/**
 * @author 何秀刚
 * Class Description: 首页业务逻辑处理Service接口
 * Create Date:2016年4月18日
 * Update Date:2016年4月18日
 */
public interface HomeService {
	
	/**
	 * 获取现在正在使用的Banner以及广告位
	 */
	public List<ActionBannerImage> selectNowBannerByType();

	/**
	 * 根据用户Openid，获取会员信息
	 * @param openid
	 * @return
	 */
	public Member selectMemberInfoByOpenId(String openid);


	/**
	 * 根据用户Openid，修改微信获取到的信息
	 * @param member 会员信息实体类
	 * @return
	 */
	public Integer updateWechatMemberInfoByByOpenid(Member member);

	/**
	 * 添加会员信息
	 * @param member
	 * @return
	 */
	public Integer insertMemberInfo(Member member);

	/**
	 * 根据用户openid，更新用户的上线
	 * @param member
	 * @return
	 */
	public Integer updateUserResAndTypeByOpenid(Member member);

	/**
	 * 根据Openid，更新用户状态为取消关注状态
	 * @param openid
	 * @return
	 */
	public Integer updateMemberStatusByOpenId(String openid);

	/**
	 * 根据用户Openid获取用户二维码(不一定有)
	 * @param openid
	 * @return
	 */
	public Member selectMemberQrcodeUrlByOpenid(String openid);

	/**
	 * 修改用户所属二维码
	 * @param member
	 * @return
	 */
	public Integer updateMemberQrcodeByOpenid(Member member);

	/**
	 * 根据代理商ID，获取激活此代理商的用户信息
	 * @param placeId
	 * @return
	 */
	public Member selectUserInfoByPlaceId(Integer placeId);
	
	/**
	 * 根据Openid，更新绑定状态
	 * @param member
	 * @return
	 */
	public Integer updateMemberIsFlagByOpenid(Member member);
}
