package com.iamberry.wechat.face.order;

import java.util.List;

import com.iamberry.wechat.core.entity.order.Order;
import com.iamberry.wechat.core.entity.order.ProbationCode;
import com.iamberry.wechat.core.entity.order.ProbationOrderDto;
import com.iamberry.wechat.core.entity.probation.ProbationAwardRelu;
import com.iamberry.wechat.core.entity.probation.ProbationNewLogs;
import com.iamberry.wechat.core.entity.probation.ProbationUserInfo;
import com.iamberry.wechat.core.entity.probation.ProbationUserDto;
import com.iamberry.wechat.core.entity.product.Product;

/**
 * 试用订单 
 * 22016年11月15日17:29:03
 * @author LJK
 *
 */
public interface ProbationShopOrderService {
	
	//根据用户openID 查询会员试用订单
	public List<ProbationOrderDto> selectProbationOrderByOpenid(String openId);
	
	/**
	 * 查询所有状态是可用的 试用订单奖励规则 并按天数升序排列
	 * @return
	 */
	public List<ProbationAwardRelu> selectProbationAwardRelu();
	
	//查询所有试用开始订单
	public List<ProbationOrderDto> selectProbationStartOrder();
	
	//根据订单ID查询 发放奖励阶段
	public ProbationNewLogs selectProbationNewLogsByOrderId(String logsOrderid);
		
	//添加奖励推送日志
	public Integer insertProbationLogs(ProbationNewLogs probationNewLogs);
	
	//修改奖励推送日志推送小时数
	public Integer updatePauseLogsDate(ProbationNewLogs probationNewLogs);
	
	//根据手机号查询验证码信息
	public ProbationCode selectProbationCodeByTel(String puserTel);
	//添加奖励推送code
	public Integer insertProbationCode(ProbationCode probationCode);
	
	//修改奖励推送code 
	public Integer updatePauseCode(ProbationCode probationCode);
	
	//查询是否已存在申请记录
	public ProbationUserInfo selectProbationOrderByTel(String puserTel);
	/**
	 * 根据商品id查询商品信息
	 * @param productId
	 * @return
	 */
	public Product selectProductInfo(Integer productId, Integer colorId);
	
	/**
	 * 添加试用订单信息
	 * @param probationOrderDto
	 * @return
	 */
	public Integer addProbationOrder(ProbationOrderDto probationOrderDto);
	
	/**
	 * 添加试用人信息
	 * @param probationUserDto
	 * @return
	 */
	public Integer addProbationUser(ProbationUserDto probationUserDto);
	
	/**
	 * 根据orderId 查询一个试用订单
	 * 2016年11月18日
	 * mzx
	 * @param orderId
	 * @return
	 */
	public ProbationOrderDto selectProbationOrderByOrderId(String orderId);
	
	/**
	 * 添加销售订单信息
	 * @param order
	 * @return
	 */
	public Integer insertSalesOrder(String probationOrderId, Integer userId);
	
	/**
	 * 根据电话号码查询订单个数
	 * @param probationTel
	 * @return
	 */
	public Integer selectProbationOrderCountByTel(String probationTel);

	/**
	 * 查询未拉取的订单
	 * @return
	 */
    public List<Order> selectProbationShopOrderList();

	/**
	 * 更新拉取成功的订单
	 * @return
	 */
	public void updateProbationShopOrder(Order order);
}
