package com.iamberry.wechat.face.pay;

import com.iamberry.wechat.core.entity.pay.PayResult;
import com.iamberry.wechat.tools.ResponseJson;

/**
 * @author 何秀刚
 * Class Description: 微信支付Servier接口
 * Create Date:2016年4月19日
 * Update Date:2016年4月19日
 */
public interface PayService {

	/**
	 * 获取发起微信支付的数据
	 * @param openid 用户openid
	 * @param orderId 订单编号
	 * @param money 订单金额，单位为分
	 * @param reqPayGoodsName 发起支付的产品名称
	 * @param backUrl 回调的URL
	 * @return PayResult, isPaySuccess = true, payData为支付数据;isPaySuccess = false, payData为失败说明.
	 */
	public PayResult requestPay(String openid, String orderId, Integer money, String reqPayGoodsName, String backUrl);

}
