package com.iamberry.wechat.face.porduct;

import java.util.List;

import org.springframework.web.servlet.ModelAndView;

import com.iamberry.wechat.core.entity.product.Product;
import com.iamberry.wechat.core.entity.product.ProductPicture;

/**
 * 产品信息处理service
 * 2016年4月21日
 * @author Administrator
 *
 */
public interface ProductService {
	
	/**
	 * 获取所有产品信息并分页
	 * 2016年4月21日
	 * @author 穆再兴
	 * @param page
	 * @return
	 */
	public List<Product> selectAllProductInfo(Product product);
	
	/**
	 * 根据productId 查询单个产品
	 * 2016年4月22日
	 * @author 穆再兴
	 * @param productId
	 * @return
	 */
	public Product selectProductByProductId(Integer productId);
	
	/**
	 * 查所有产品个数 后台分页用
	 * 2016年4月23日
	 * @author 穆再兴
	 * @return
	 */
	public Integer selectProductCount(Product product);
	
	/**
	 * 查所有产品的id和name 用来创建产品的下拉框
	 * 2017年2月14日
	 * @author muzx
	 * @return
	 */
	public List<Product> selectProductIdAndName();
	
	/**
	 * 添加一个产品		返回 productId
	 * 2016年4月21日
	 * @author 穆再兴
	 * @return
	 */
	public ModelAndView addProduct(Product product, List<ProductPicture> picList);
	
	/**
	 * 根据 productId 修改一个产品的信息
	 * 2016年4月22日
	 * @author 穆再兴
	 * @param product
	 * @return
	 */
	public ModelAndView updateProductByProductId(Product product, String[] imageUrls);
	
	/**
	 * 根据 productId 修改一个产品的状态
	 * 2016年4月22日
	 * @author 穆再兴
	 * @param product
	 * @return
	 */
	public Integer updateProductStatusByProductId(Product product);
}
