package com.iamberry.wechat.service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.concurrent.CopyOnWriteArraySet;

import org.owasp.validator.html.AntiSamy;
import org.owasp.validator.html.Policy;
import org.owasp.validator.html.PolicyException;
import org.springframework.web.socket.WebSocketSession;

import com.iamberry.wechat.autiXSS.AntiXSS;
import com.iamberry.wechat.core.entity.admin.ShopSystemRule;
import com.iamberry.wechat.core.entity.banner.ActionBannerImage;
import com.iamberry.wechat.core.entity.product.Product;
import com.iamberry.wechat.core.entity.wx.Config;
import com.iamberry.wechat.core.entity.wx.Token;

/**
 * @author 何秀刚
 * @description: 静态资源缓存
 * Create Date:2016年4月18日
 * Update Date:2016年4月18日
 */
public class StaticCacheMemory {

	/** XSS过滤 */
	public final static AntiXSS XSS = new AntiXSS();
	/** 是否启动task:保证多线程安全 */
	public static volatile boolean isStartTask = true;
	/** anti-samy过滤规则 */
	public static Policy policy = null;
	public static AntiSamy antiSamy = new AntiSamy();
    /** 系统监控 */
	public static List<Map<String, Integer>> lists = 
			new ArrayList<Map<String,Integer>>(); // 系统请求
	public static final int count = 30; // 结算公式为: count * 16 = 系统单点承受并发量
}
