package com.iamberry.wechat.service.agent.dao.impl;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.iamberry.wechat.core.entity.agent.AgentMemberDto;
import com.iamberry.wechat.service.agent.dao.AgentMemberDAO;
import com.iamberry.wechat.service.mapper.AgentMemberMapper;

/**
 * 微代理会员中心	DAO实现类
 * 2016年4月20日
 * @author 穆再兴
 *
 */
@Repository
public class AgentMemberDAOImpl implements AgentMemberDAO{
	@Autowired
	private AgentMemberMapper agentMemberMapper;
	/**
	 * 根据openid获取该用户 各种状态的订单数量
	 * 2016年4月20日
	 * @author 穆再兴
	 * @param openid
	 * @return
	 */
	@Override
	public List<Map<String, Integer>> getMyOrderStatusCount(String openid) {
		return agentMemberMapper.getMyOrderStatusCount(openid);
	}
	/**
	 * 获取当前用户微代理信息
	 * 2016年4月20日
	 * @author 穆再兴
	 * @return
	 */
	@Override
	public AgentMemberDto getAgentMemberInfo(String openid) {
		return agentMemberMapper.getAgentMemberInfo(openid);
	}

	/**
	 * 查询当前用户<微代理>的待返还金额 <包括下线将返的100 及下线的下线将返还的40>
	 * 2016年5月19日
	 * @author mzx
	 * @return
	 */
	public Integer getWillIncomeByOpenId(String openid){
		return agentMemberMapper.getWillIncomeByOpenId(openid);
	}
}
