package com.iamberry.wechat.service.coupon;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.iamberry.wechat.core.entity.coupon.CouponType;
import com.iamberry.wechat.face.coupon.CouponTypeService;
import com.iamberry.wechat.service.mapper.CouponTypeMapper;

/**
 * 优惠券类型 service实现
 * 2016年7月6日
 * @author Administrator
 *
 */
@Service
public class CouponTypeServiceImpl implements CouponTypeService {
	@Autowired
	private CouponTypeMapper couponTypeMapper;
	
	/**
	 * 查询优惠券类型列表并分页
	 * 2016年7月6日
	 * @author 穆再兴
	 * @return
	 */
	public List<CouponType> getCouponTypeList(CouponType couponType){
		couponType.getPage().initRecordBegin();
		return couponTypeMapper.getCouponTypeList(couponType);
	}
	
	/**
	 * 查询优惠券类型总数
	 * 2016年7月6日
	 * @author 穆再兴
	 * @return
	 */
	public Integer getCouponTypeCount(){
		return couponTypeMapper.getCouponTypeCount();
	}
	
	/**
	 * 添加一个优惠券类型
	 * 2016年7月6日
	 * @author 穆再兴
	 * @param couponType
	 * @return
	 */
	public Integer insertCouponType(CouponType couponType){
		return couponTypeMapper.insertCouponType(couponType);
	}
	
	/**
	 * 根据id查询一个优惠券类型
	 * 2016年7月6日
	 * @param couponId
	 * @return
	 */
	public CouponType getCouponTypeById(Integer couponId){
		return couponTypeMapper.getCouponTypeById(couponId);
	}
	
	/**
	 * 领取优惠券时 优惠券类型减一
	 * 2016年7月7日
	 * @return
	 */
	public Integer updateCouponTypeForItem(Integer couponId){
		return couponTypeMapper.updateCouponTypeForItem(couponId);
	}

	@Override
	public Integer updateCouponTypeById(CouponType couponType) {
		// TODO Auto-generated method stub
		return couponTypeMapper.updateCouponTypeById(couponType);
	}

	@Override
	public Integer deleteCouponTypeById(Integer couponId) {
		// TODO Auto-generated method stub
		return couponTypeMapper.deleteCouponTypeById(couponId);
	}

	@Override
	public List<CouponType> getUnGetCoupon(String openid) {
		// TODO Auto-generated method stub
		return couponTypeMapper.getUnGetCouponType(openid);
	}
}
