package com.iamberry.wechat.service.mapper;

import com.iamberry.wechat.core.entity.wx.FirstJoinKey;

/**
 * 首次关注消息推送，映射文件接口
 * @author liurui     Email:972376971@qq.com
 * @version 创建时间：2015年5月7日  下午5:38:35
 */
public interface FirstJoinKeyMapper {
	
	/**
	 * 根据微信公众号， 获取首次关注回复内容
	 *  获取首次关注回复的FirstJoinKey对象
	 * @param wxpublicNo
	 * @return
	 */
	public FirstJoinKey selectOne(String wxpublicNo);
	
	/**
	 * 修改或者是首次关注的消息回复
	 * 
	 *  根据微信公众号ID修改首次关注回复
	 *  返回修改状态1或0
	 */
	public int updateOne(FirstJoinKey firstJoinKey);
	
	/**
	 * 
	 * 如果数据库中没有该数据，那么选择插入数据
	 */
	public int addOne(FirstJoinKey firstJoinKey);
}
