package com.iamberry.wechat.service.mapper;

import java.util.List;

import com.iamberry.wechat.core.entity.giftCard.GiftCardPayCode;


/**
 * 支付密码信息	mapper
 * @author muzx
 * create date : 2017年2月16日
 */
public interface GiftCardPayCodeMapper {
    /**
     * 添加抵扣密码记录
     * 2017年3月3日
     * @author muzx
     * @param payCode
     * @return
     */
    Integer insertPayCodeList(List<GiftCardPayCode> payCodeList);
    
    /**
     * 获取所有支付密码并分页
     * 2017年3月15日
     * @author muzx
     * @return
     */
    List<GiftCardPayCode> listPayCode(GiftCardPayCode payCode);
    /**
     * 查询所有支付密码总数
     * 2017年3月15日
     * @author muzx
     * @return
     */
    int countPayCode();
    /**
     * 根据id或支付密码 查询一个支付密码信息
     * 2017年3月1日
     * @author muzx
     * @param payCode
     * @return
     */
    GiftCardPayCode getPayCodeByIdOrPassword(GiftCardPayCode payCode);
    
    /**
     * 根据openid 修改使用状态和使用人openid
     * 2017年3月2日
     * @author muzx
     * @param payCode
     * @return
     */
    Integer updatePayCodeStatusAndUseOpenId(GiftCardPayCode payCode);
}
