package com.iamberry.wechat.service.mapper;

import java.util.List;

import com.iamberry.wechat.core.entity.machine.Machine;
import com.iamberry.wechat.core.entity.machine.MachineDto;
import com.iamberry.wechat.core.entity.machine.MachineRechargeDto;
import com.iamberry.wechat.core.entity.machine.MachineShareRecord;

public interface LeaseMachineMapper {

	/**
	 * 新增机器信息
	 * @param machine
	 * @return
	 */
	public Integer insertMachineInfo(Machine machine);
	
	/**
	 * 新增充值记录信息
	 * @param machineRechargeDto
	 * @return
	 */
	public Integer insertMachineRecharge(MachineRechargeDto machineRechargeDto);
	
	/**
	 * 按openId查询机器充值列表
	 * @param machineRechargeDto
	 * @return
	 */
	public List<MachineRechargeDto> selectMachineRechargeList(MachineRechargeDto machineRechargeDto);
	
	/**
	 * 根据openId查询机器列表信息
	 * @param machineDto
	 * @return
	 */
	public List<MachineDto> selectMachineList(MachineDto machineDto);
	
	/**
	 * 生成分享记录
	 * @param machineShare
	 * @return
	 */
	public Integer insertShareRecord(MachineShareRecord machineShare);
}
