package com.iamberry.wechat.service.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.iamberry.wechat.core.entity.admin.AdminChildHavePermission;
import com.iamberry.wechat.core.entity.admin.AdminChildPermissionErmissions;
import com.iamberry.wechat.core.entity.admin.AdminChildPermissions;
import com.iamberry.wechat.core.entity.order.ProbationOrder;
import com.iamberry.wechat.core.entity.probation.ProbationUserInfo;

/**
 * description : 对应所有的二级管理员权限
 * @author 何秀刚
 * create date : 2015年12月10日
 */
public interface ProbationMapper {
	
	/**
	 * 添加-试用人-信息
	 * @param prouserinfo 试用人信息，实体类
	 * @return 影响行数
	 */
	public int addProbationUser(ProbationUserInfo prouserinfo);
	
	
	/**
	 * 添加-试用人- 订单信息
	 * @param ProbationOrder 试用人 订单信息
	 * @return 影响行数
	 */
	public int addProbationUserOrder(ProbationOrder prouserorder);
	
	

	/**
	 * 获取试用人，，订单
	 * @param openid 试用人信息
	 * @return
	 */
	public ProbationOrder getProbationOrderDetail(String orderid);
	
	
}
