package com.iamberry.wechat.service.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.iamberry.wechat.core.entity.giftCard.UserMachineInfo;

/**
 * 用户兑换记录Mapper
 * @company	深圳爱贝源科技有限公司
 * @website www.iamberry.com
 * @author 	献
 * @tel		18271840547
 * @date	2017年2月16日
 */
public interface UserMachineInfoMapper {
	
	/**
	 * 添加兑换记录
	 * @param info
	 * @return
	 * @author 献
	 * @Time   2017年2月16日
	 */
	public int add(UserMachineInfo info);
	
	/**
	 * 根据用户的openid 获取兑换记录
	 * @param openid
	 * @return
	 * @author 献
	 * @Time   2017年2月16日
	 */
	public List<UserMachineInfo> list(String openid);
	
	/**
	 * 获取一页的待发货的兑换数据
	 * @param min
	 * @param max
	 * @return
	 * @author 献
	 * @Time   2017年2月16日
	 */
	public List<UserMachineInfo> page(@Param("min") int min, @Param("max") int max);
	
	/**
	 * 获取总的待处理兑换记录条数
	 * @return
	 * @author 献
	 * @Time   2017年2月16日
	 */
	public int count();
	
	/**
	 * 修改兑换信息
	 * @param info
	 * @return
	 * @author 献
	 * @Time   2017年2月17日
	 */
	public int update(UserMachineInfo info);
}
