package com.iamberry.wechat.service.product;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.iamberry.wechat.core.entity.product.ProductPicture;
import com.iamberry.wechat.face.porduct.ProductPictureService;
import com.iamberry.wechat.service.product.dao.ProductPictureDAO;

/**
 * 产品介绍图  Service实现类
 * 2016年4月24日
 * @author 穆再兴
 *
 */
@Service
public class ProductPictureServiceImpl implements ProductPictureService {

	@Autowired
	private ProductPictureDAO productPictureDAO;
	
	/**
	 * 为产品添加一个介绍图
	 * 2016年4月24日
	 * @author 穆再兴
	 * @param productPicture
	 * @return
	 */
	@Override
	public Integer addProductPicture(ProductPicture productPicture) {
		return productPictureDAO.addProductPicture(productPicture);
	}

	/**
	 * 根据图片id删除一个产品的介绍图
	 * 2016年4月24日
	 * @author 穆再兴
	 * @param pictureId
	 * @return
	 */
	public Integer deleteProductPicture(Integer pictureId){
		return productPictureDAO.deleteProductPicture(pictureId);
	}
	
	/**
	 * 根据产品id 查出该产品所有介绍图信息
	 * 2016年4月24日
	 * @author 穆再兴
	 * @return
	 */
	public List<ProductPicture> getProductPictureByproductId(Integer productId){
		return productPictureDAO.getProductPictureByproductId(productId);
	}
}
