package com.iamberry.wechat.service.product.dao.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.iamberry.wechat.core.entity.product.ProductImageText;
import com.iamberry.wechat.service.mapper.ProductImageTextMapper;
import com.iamberry.wechat.service.product.dao.ProductImageTextDAO;

/**
 * 产品图文 DAO实现
 * 2016年4月24日
 * @author 穆再兴
 *
 */
@Repository
public class ProductImageTextDAOImpl implements ProductImageTextDAO {

	@Autowired
	private ProductImageTextMapper productImageTextMapper;
	
	/**
	 * 为某个产品添加 一条图文信息
	 * 2016年4月24日
	 * @author 穆再兴
	 * @return
	 */
	@Override
	public Integer addProductImageText(ProductImageText productImageText) {
		return productImageTextMapper.addProductImageText(productImageText);
	}
	
	/**
	 * 根据productId 查出一条图文信息
	 * 2016年4月24日
	 * @author 穆再兴
	 * @param productId
	 * @return
	 */
	public ProductImageText getProductImageTextByProduectId(Integer productId){
		return productImageTextMapper.getProductImageTextByProduectId(productId);
	}

	/**
	 * 根据 图文id 修改一个产品的图文信息
	 * 2016年4月24日
	 * @param 穆再兴
	 * @return
	 */
	public Integer updateProductImageTextById(ProductImageText productImageText){
		return productImageTextMapper.updateProductImageTextById(productImageText);
	}
}
