package com.iamberry.wechat.service.product.dao.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.iamberry.wechat.core.entity.product.ProductPicture;
import com.iamberry.wechat.service.mapper.ProductPictureMapper;
import com.iamberry.wechat.service.product.dao.ProductPictureDAO;

/**
 * 产品介绍图  DAO实现类
 * 2016年4月24日
 * @author 穆再兴
 *
 */
@Repository
public class ProductPictureDAOImpl implements ProductPictureDAO {

	@Autowired
	private ProductPictureMapper productPictureMapper;
	
	/**
	 * 为产品添加一个介绍图
	 * 2016年4月24日
	 * @author 穆再兴
	 * @param productPicture
	 * @return
	 */
	@Override
	public Integer addProductPicture(ProductPicture productPicture) {
		return productPictureMapper.addProductPicture(productPicture);
	}
	
	/**
	 * 根据图片id删除一个产品的介绍图
	 * 2016年4月24日
	 * @author 穆再兴
	 * @param pictureId
	 * @return
	 */
	public Integer deleteProductPicture(Integer pictureId){
		return productPictureMapper.deleteProductPicture(pictureId);
	}

	/**
	 * 根据产品id 查出该产品所有介绍图信息
	 * 2016年4月24日
	 * @author 穆再兴
	 * @return
	 */
	public List<ProductPicture> getProductPictureByproductId(Integer productId){
		return productPictureMapper.getProductPictureByproductId(productId);
	}
}
