package com.iamberry.wechat.handles.official;

import com.iamberry.wechat.core.entity.ResultMsg;
import com.iamberry.wechat.core.entity.official.Prospectus;
import com.iamberry.wechat.face.official.ProspectusService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;

/**
 * @author Administrator
 */
@Controller
public class ProspectusHandler {

	@Autowired
	ProspectusService prospectusService;

	/**
	 *
	 * @param request
	 * @return
	 * @throws Exception
	 */
	@ResponseBody
	@RequestMapping("/official/getProspectus")
	public ResultMsg getCartNumByCartOpenId(HttpServletRequest request,String prospectusCode) throws Exception {
		ResultMsg remsg=new ResultMsg();
		Prospectus prospectus  = prospectusService.getProspectusByCode(prospectusCode);
		if(prospectus == null){
			return new ResultMsg(true, ResultMsg.SUCCESS, "未查询到授权码!",null);
		}
		//prospectusTime
		if(prospectus.getProspectusTime().before(new Date())){
			return new ResultMsg(true, ResultMsg.SUCCESS, "未查询到授权码!",null);
		};
		if(prospectus.getProspectusStatus() == 2){
			return new ResultMsg(true, ResultMsg.SUCCESS, "未查询到授权码!",null);
		};
		if(prospectus.getProspectusStatus() == 1){
			remsg.setMessage("授权码可用");
		}
		remsg.setData(prospectus);
		return remsg;
	}


}
