<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">
<meta name="renderer" content="webkit|ie-comp|ie-stand">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta name="viewport"
	content="width=device-width,initial-scale=1,minimum-scale=1.0,maximum-


scale=1.0,user-scalable=no" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<LINK rel="Bookmark" href="/favicon.ico">
<LINK rel="Shortcut Icon" href="/favicon.ico" />
<!--[if lt IE 9]>
<script type="text/javascript" src="lib/html5.js"></script>
<script type="text/javascript" src="lib/respond.min.js"></script>
<script type="text/javascript" src="lib/PIE_IE678.js"></script>
<![endif]-->
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.min.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.admin.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/skin/default/skin.css" rel="stylesheet" type="text/css" id="skin" />
<link href="${pageContext.request.contextPath }/common/admin/lib/Hui-iconfont/1.0.1/iconfont.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/style.css" rel="stylesheet" type="text/css" />
<!--[if IE 6]>
<script type="text/javascript" src="lib/DD_belatedPNG_0.0.8a-min.js" ></script>
<script>DD_belatedPNG.fix('*');</script>
<![endif]-->
<title>系统规则列表</title>
</head>
<body>
	<nav class="breadcrumb">
		<i class="Hui-iconfont">&#xe67f;</i> 首页 <span class="c-gray en">&gt;</span>
		商城系统规则 <span class="c-gray en">&gt;</span>商城系统规则列表 <a
			class="btn btn-success radius r mr-20"
			style="line-height: 1.6em; margin-top: 3px"
			href="javascript:location.replace(location.href);" title="刷新"><i
			class="Hui-iconfont">&#xe68f;</i></a>
	</nav>
	<div class="pd-20">
	<form id="adminlist" >
		<table class="table table-border table-bordered table-bg">
			<thead>
				<tr>
					<th scope="col" colspan="9">商城系统规则列表</th>
				</tr>
				<tr class="text-c">
					<th width="150">奖励简介</th>
					<th width="90">奖励数量</th>
					<th width="150">奖励类型</th>
					<th width="130">创建时间</th>
					<th width="100">是否已启用</th>
					<th width="100">操作</th>
				</tr>
			</thead>
			<tbody>
				<c:if test="${! (empty goodsSystemRuleList) }">
					<c:forEach items="${goodsSystemRuleList }" var="infolist">
						<tr class="text-c">
							<td>${infolist.systemRuleDesc }</td>
							<td>${infolist.systemRuleNum }</td>
							<td>${infolist.systemRuleType }</td>
							<td><fmt:formatDate value="${infolist.systemRuleCreateDate }" pattern="yyyy-MM-dd"/></td>
							<td class="td-status"><c:if test="${infolist.systemRuleStatus == 1 }">
														<span class="label label-success radius">已启用</span>
												  </c:if>
												  <c:if test="${infolist.systemRuleStatus == 2 }">
												   		<span class="label  radius">已停用</span>
												   </c:if>
												   </td>
							<td class="td-manage">
							<c:if test="${infolist.systemRuleStatus == 1 }">
								<a onClick="systemRule_stop(this,'${infolist.systemRuleId }','${infolist.systemRuleStatus }')" href="javascript:;" title="停用" style="text-decoration:none"><i class="Hui-iconfont">&#xe631;</i></a>
							</c:if>
							<c:if test="${infolist.systemRuleStatus == 2 }">
								<a style="text-decoration:none" onClick="systemRule_start(this,'${infolist.systemRuleId }','${infolist.systemRuleStatus }')" href="javascript:;" title="启用"><i class="Hui-iconfont">&#xe615;</i></a>
							</c:if>
							<a title="编辑" href="javascript:;" onclick="systemRule_edit('${pageContext.request.contextPath }/admin/goodsSystemRule/toupdateSystemRuleUI/${infolist.systemRuleId }')" class="ml-5" style="text-decoration:none"><i class="Hui-iconfont">&#xe6df;</i></a> 
							</td>
					</c:forEach>
				</c:if>
			</tbody>
		</table>
		<div align="right" class="mt-10 mb-10 mr-10">
			<%@include file="/common/other/paper/pager.jsp"%>
  		</div>
  		</form>
	</div>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/jquery/1.9.1/jquery.min.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/layer/1.9.3/layer.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.admin.js"></script>
	<script type="text/javascript">
/*
*	参数解释：
*	title	标题
*	url		请求的url
*	id		需要操作的数据id
*	w		弹出层宽度（缺省调默认值）
*	h		弹出层高度（缺省调默认值）
*/
/*管理员-编辑*/
function systemRule_edit(url){
	window.location.href = url;
}
/*系统规则-停用*/
function systemRule_stop(obj,id,Status){
	layer.confirm('确认要停用吗？',function(index){
		//此处请求后台程序，下方是成功后的前台处理……
		$.ajax({
              url: '${pageContext.request.contextPath }/admin/goodsSystemRule/updateSystemRulestatus',
              type: "POST",
              dataType: "json",
              data: {systemRuleId:id,systemRuleStatus:Status},
              error:function(){
            	  layer.msg(data.status,{icon: 5,time:2000});
              },
              success:  function(data){
            	  layer.msg(data.status,{icon: 1,time:1000});
            	  $(obj).parents("tr").find(".td-manage").prepend('<a onClick="systemRule_start(this,'+id + ',2)" href="javascript:;" title="启用" style="text-decoration:none"><i class="Hui-iconfont">&#xe615;</i></a>');
          		  $(obj).parents("tr").find(".td-status").html('<span class="label label-default radius">已停用</span>');
          		  $(obj).remove();
          		  layer.msg('已停用!',{icon: 5,time:1000});
              }
          });
		
	});
}
/*系统规则-启用*/
function systemRule_start(obj,id,Status){
	layer.confirm('确认要启用吗？',function(index){
		//此处请求后台程序，下方是成功后的前台处理……
		 $.ajax({
              url: '${pageContext.request.contextPath }/admin/goodsSystemRule/updateSystemRulestatus',
              type: "POST",
              dataType: "json",
              data: {systemRuleId:id,systemRuleStatus:Status},
              error:function(){
            	  layer.msg(data.status,{icon: 5,time:2000});
              },
              success:  function(data){
            	  $(obj).parents("tr").find(".td-manage").prepend('<a onClick="systemRule_stop(this,'+id+',1)" href="javascript:;" title="停用" style="text-decoration:none"><i class="Hui-iconfont">&#xe631;</i></a>');
          		  $(obj).parents("tr").find(".td-status").html('<span class="label label-success radius">已启用</span>');
          		  $(obj).remove();
          		  layer.msg('已启用!', {icon: 6,time:1000});
              }
          });
	});	
}
</script>
</body>
</html>