<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">
<meta name="renderer" content="webkit|ie-comp|ie-stand">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta name="viewport" content="width=device-width,initial-scale=1,minimum-scale=1.0,maximum-scale=1.0,member-scalable=no" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<!--[if lt IE 9]>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/html5.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/respond.min.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/PIE_IE678.js"></script>
<![endif]-->
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.min.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.admin.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/lib/Hui-iconfont/1.0.1/iconfont.css" rel="stylesheet" type="text/css" />
<!--[if IE 6]>
<script type="text/javascript" src="http://lib.h-ui.net/DD_belatedPNG_0.0.8a-min.js" ></script>
<script>DD_belatedPNG.fix('*');</script>
<![endif]-->
<title>线下订单管理</title>
</head>
<body>
<nav class="breadcrumb"><i class="Hui-iconfont">&#xe67f;</i> 首页 <span class="c-gray en">&gt;</span> 订单管理 <span class="c-gray en">&gt;</span> 线下订单列表 <a class="btn btn-success radius r mr-20" style="line-height:1.6em;margin-top:3px" href="javascript:location.replace(location.href);" title="刷新" ><i class="Hui-iconfont">&#xe68f;</i></a></nav>
<div class="pd-20">
	<form action="${pageContext.request.contextPath }/admin/etcOrder/offlineListUI" method="post" id="form-admin-add">
	<div class="text-c"> 
		日期范围：
		<input readonly="readonly" type="text" onfocus="WdatePicker({maxDate:'#F{$dp.$D(\'endDate\')||\'2020-10-01\'}'})" id="beginDate" name="beginDate" value="${beginDate }" class="input-text Wdate" style="width: 120px;">
		- <input readonly="readonly" type="text" onfocus="WdatePicker({minDate:'#F{$dp.$D(\'beginDate\')}',maxDate:'2020-10-01'})" id="endDate" name="endDate" value="${endDate }" class="input-text Wdate" style="width: 120px;">
		<input type="text" class="input-text" style="width:250px" placeholder="输入姓名、电话、身份证号码" value="${selectInput }" id="" name="text">
		<button type="submit" class="btn btn-success radius" id="" name=""><i class="Hui-iconfont">&#xe665;</i> 搜订单</button>
	</div>
	</form>
	<!-- <div class="cl pd-5 bg-1 bk-gray mt-20"> <span class="l"><a href="javascript:;" onclick="datadel()" class="btn btn-danger radius"><i class="Hui-iconfont">&#xe6e2;</i> 批量删除</a> <a href="javascript:;" onclick="member_add('添加用户','member-add.html','','510')" class="btn btn-primary radius"><i class="Hui-iconfont">&#xe600;</i> 添加用户</a></span> <span class="r">共有数据：<strong>88</strong> 条</span> </div> -->
	<div class="mt-20">
	<table class="table table-border table-bordered table-hover table-bg table-sort">
		<thead>
			<tr class="text-c">
				<th width="100">订单ID</th>
				<th width="100">试用人姓名</th>
				<th width="100">试用人电话</th>
				<th width="100">试用人身份证号</th>
				<th width="100">正面照片</th>
				<th width="100">反面照片</th>
				<th width="100">创建类型</th>
				<th width="100">付款状态</th>
				<th width="100">金额</th>
				<th width="100">时间</th>
			</tr>
		</thead>
		<tbody>
			<c:if test="${!(empty list) }">
				<c:forEach items="${list }" var="user">
					<tr class="text-c">
						<td>${user.offlineEtcId }</td>
						<td>${user.offlineEtcName }</td>
						<td>${user.offlineEtcTel }</td>
						<td>${user.offlineEtcNO }</td>
						<td>
							<img alt="正面照片" src="${pageContext.request.contextPath }${user.offlineEtcUrl1 }" style="width:50px;height: 50px">
						</td>
						<td>
							<img alt="反面照片" src="${pageContext.request.contextPath }${user.offlineEtcUrl2 }" style="width:50px;height: 50px">
						</td>
						<td>${user.offlineEtcType == 1 ? "线下试用时录入":"付款时，未获取到信息时系统录入" }</td>
						<td>${user.offlineEtcStatus == 1 ? "等待付款" : "已付款" }</td>
						<td>${user.offlineEtcNum }</td>
						<td><fmt:formatDate value="${user.offlineEtcDate }" pattern="yyyy-MM-dd HH:mm:ss"/></td>
				</tr>
				</c:forEach>
			</c:if>
			<c:if test="${empty list }">
				<tr class="text-c">
					<td colspan="11">没有查询到数据</td>
				</tr>
			</c:if>
		</tbody>
	</table>
	</div>
</div>
<div align="right">
	<%@include file="/common/other/paper/pager.jsp"%>
</div>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/jquery/1.9.1/jquery.min.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/layer/1.9.3/layer.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/laypage/1.2/laypage.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/My97DatePicker/WdatePicker.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/datatables/1.10.0/jquery.dataTables.min.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.admin.js"></script> 
<script type="text/javascript">

$(function() {
	$("#DataTables_Table_0_paginate").hide();
	$("#DataTables_Table_0_length").hide();
	$("#DataTables_Table_0_info").hide();
});
</script> 
</body>
</html>