<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">
<meta name="renderer" content="webkit|ie-comp|ie-stand">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta name="viewport"
	content="width=device-width,initial-scale=1,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<LINK rel="Bookmark" href="/favicon.ico">
<LINK rel="Shortcut Icon" href="/favicon.ico" />
<!--[if lt IE 9]>
<script type="text/javascript" src="lib/html5.js"></script>
<script type="text/javascript" src="lib/respond.min.js"></script>
<script type="text/javascript" src="lib/PIE_IE678.js"></script>
<![endif]-->
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.min.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.admin.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/skin/default/skin.css" rel="stylesheet" type="text/css" id="skin" />
<link href="${pageContext.request.contextPath }/common/admin/lib/Hui-iconfont/1.0.1/iconfont.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/style.css" rel="stylesheet" type="text/css" />

<!--[if IE 6]>
<script type="text/javascript" src="lib/DD_belatedPNG_0.0.8a-min.js" ></script>
<script>DD_belatedPNG.fix('*');</script>
<![endif]-->
<title>产品颜色列表</title>
</head>
<body>
	<nav class="breadcrumb">
		<i class="Hui-iconfont">&#xe67f;</i> 首页 <span class="c-gray en">&gt;</span>
		商城管理 <span class="c-gray en">&gt;</span> 产品颜色列表 <a
			class="btn btn-success radius r mr-20"
			style="line-height: 1.6em; margin-top: 3px"
			href="javascript:location.replace(location.href);" title="刷新"><i
			class="Hui-iconfont">&#xe68f;</i></a>
	</nav>
	<div class="pd-20">
	<form id="goodsform" >
		<div class="cl pd-5 bg-1 bk-gray mt-20">
			<span class="l"><a href="javascript:;" onclick="toAdd('${pageContext.request.contextPath }/admin/product_color/to_add')"
				class="btn btn-danger radius">添加颜色</a>&nbsp;
		    </span>
		</div>
		<table class="table table-border table-bordered table-bg" id="example">
			<thead>
				<tr>
					<th scope="col" colspan="11">产品颜色列表</th>
				</tr>
				<tr class="text-c">
					<!-- <th width="25"><input type="checkbox" name="" value=""></th> -->
					<th width="150">颜色名称</th>
					<th width="200">产品名称</th>

					<th width="90">产品市场价</th>
					<th width="90">产品折扣价</th>
					<th width="100">产品69码</th>
					
					<th width="100">创建时间</th>
					<th width="100">修改时间</th>
					<th width="100">操作</th>
				</tr>
			</thead>
	
			<tbody>
				<c:if test="${! (empty list) }">
					<c:forEach items="${list }" var="color">
						<input type="hidden" name="colorId" value="${color.colorId }"/>
						<input type="hidden" name="colorProductId" value="${color.colorProductId }"/>
						<tr class="text-c">
							<%-- <td><input type="checkbox" value="${product.productId }" name="productId"></td> --%>
							<td>${color.colorName }</td>
							<td>${color.colorProductName }</td>
							
							<td><fmt:formatNumber type="number" value="${color.colorPrice / 100} " pattern="0.00" maxFractionDigits="2"/></td>
							<td><fmt:formatNumber type="number" value="${color.colorDiscount / 100}" pattern="0.00" maxFractionDigits="2"/></td>
							<td>${color.color69Code }</td>
							
							<td width="150"><fmt:formatDate value="${color.colorCretaeTime }" pattern="yyyy-MM-dd HH:mm:ss" /></td>
							<td width="150"><fmt:formatDate value="${color.colorUpdateTime }" pattern="yyyy-MM-dd HH:mm:ss" /></td>
							<td class="td-manage">
								<a onclick="goods_edit('${pageContext.request.contextPath }/admin/product_color/to_update/${color.colorId }')" 
								title="编辑" href="javascript:;"  class="ml-5" style="text-decoration:none"><i class="Hui-iconfont">&#xe6df;</i></a> 
							</td>
					</c:forEach>
				</c:if>
			</tbody>
		</table>
		<div align="right" class="mt-10 mb-10 mr-10">
			<%@include file="/common/other/paper/pager.jsp"%>
  		</div>
  		</form>
	</div>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/jquery/1.9.1/jquery.min.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/layer/1.9.3/layer.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.admin.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/tips.js"></script> 
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/My97DatePicker/WdatePicker.js"></script> 
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/datatables/1.10.0/jquery.dataTables.min.js"></script> 
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/js/page/jqPaginator.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/goods/js/utils.js"></script>
	<script type="text/javascript">
/**
 * 进入添加页面
 */
function toAdd(url){
	window.location.href = url;
}
/**
 * 打开修改商品界面
 */
function goods_edit(url){
	window.location.href = url;
}
</script>
</body>
</html>