<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <meta charset="utf-8">
    <meta name="renderer" content="webkit|ie-comp|ie-stand">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width,initial-scale=1,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no" />
    <meta http-equiv="Cache-Control" content="no-siteapp" />
    <!--[if lt IE 9]>
    <script type="text/javascript" src="lib/html5.js"></script>
    <script type="text/javascript" src="lib/respond.min.js"></script>
    <script type="text/javascript" src="lib/PIE_IE678.js"></script>
    <![endif]-->
    <link href="${pageContext.request.contextPath }/common/admin/css/H-ui.min.css" rel="stylesheet" type="text/css" />
    <link href="${pageContext.request.contextPath }/common/admin/css/H-ui.admin.css" rel="stylesheet" type="text/css" />
    <link href="${pageContext.request.contextPath }/common/admin/lib/icheck/icheck.css" rel="stylesheet" type="text/css" />
    <link href="${pageContext.request.contextPath }/common/admin/lib/Hui-iconfont/1.0.1/iconfont.css" rel="stylesheet" type="text/css" />
    <title>订单详细信息</title>
</head>
<body>
<nav class="breadcrumb"><i class="Hui-iconfont">&#xe67f;</i> 首页 <span class="c-gray en">&gt;</span> 销售订单管理 <span class="c-gray en">&gt;</span> 订单详情 <a class="btn btn-success radius r mr-20" style="line-height:1.6em;margin-top:3px" href="javascript:location.replace(location.href);" title="刷新" ><i class="Hui-iconfont">&#xe68f;</i></a></nav>
<div class="pd-20">
    <div style="float:right;">
        <a href="javascript:window.location.href = document.referrer;" >返回</a>
    </div>
    <div id="tab-system" class="HuiTab">
        <div class="tabBar cl"><span>订单详情</span></div>
        <div class="tabCon">
            <c:if test="${!(empty logs)}">
                <table class="table table-border table-bordered table-hover mt-5">
                    <tr class="text-r">
                        <td class="f-14" style="font-weight: bold;">订单号：</td>
                        <td>${logs.logsOrderId }</td>
                        <td  class="f-14" style="font-weight: bold;">所属用户：</td>
                        <td>${logs.rentUserNickName }</td>
                        <td  class="f-14" style="font-weight: bold;">状态：</td>
                        <td width="150" colspan="3">
                            <c:choose>
                                <c:when test="${logs.logsStatus ==0 }">
                                    取消更换
                                </c:when>
                                <c:when test="${logs.logsStatus ==1 }">
                                    更换申请中
                                </c:when>
                                <c:when test="${logs.logsStatus ==2 }">
                                    更换中
                                </c:when>
                                <c:when test="${logs.logsStatus ==3 }">
                                    更换驳回
                                </c:when>
                                <c:when test="${logs.logsStatus ==4 }">
                                    已发货
                                </c:when>
                                <c:when test="${logs.logsStatus ==5 }">
                                    已完成
                                </c:when>
                            </c:choose>
                        </td>
                    </tr>
                    <tr class="text-r">
                        <td  class="f-14" style="font-weight: bold;">快递公司：</td>
                        <td>
                            <c:choose>
                                <c:when test="${logs.logsPostFirm == 'sto' }">申通快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'yto' }">圆通快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'sf' }">顺丰快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'ems' }">邮政EMS</c:when>
                                <c:when test="${logs.logsPostFirm == 'zto' }">中通快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'zjs' }">宅急送</c:when>
                                <c:when test="${logs.logsPostFirm == 'yunda' }">韵达快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'cces' }">cces快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'pick' }">上门提货</c:when>
                                <c:when test="${logs.logsPostFirm == 'htky' }">汇通快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'ttkdex' }">天天快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'stars' }">星晨急便</c:when>
                                <c:when test="${logs.logsPostFirm == 'jd' }">京东快递</c:when>
                                <c:when test="${logs.logsPostFirm == 'dbkd' }">德邦快递</c:when>
                                <c:when test="${logs.logsPostFirm == '01' }">其他</c:when>
                                <c:when test="${logs.logsPostFirm == '02' }">上门送货</c:when>
                            </c:choose>
                        </td>
                        <td  class="f-14" style="font-weight: bold;">快递单号：</td>
                        <td>${logs.logsPostNum }</td>
                        <td  class="f-14" style="font-weight: bold;">创建时间：</td>
                        <td colspan="3"><fmt:formatDate value="${logs.logsCreateTime }" pattern="yyyy-MM-dd HH:mm:ss"/></td>
                    </tr>
                    <tr class="text-r">
                        <td  class="f-14" style="font-weight: bold;">收件人姓名：</td>
                        <td >${logs.logsAddressName }</td>
                        <td  class="f-14" style="font-weight: bold;">收件人电话：</td>
                        <td >${logs.logsAddressTel }</td>
                        <td  class="f-14" style="font-weight: bold;">收货地址：</td>
                        <td colspan="4">${logs.logsAddressInfo }</td>
                    </tr>
                    <tr class="text-r">
                        <td  class="f-14" style="font-weight: bold;">滤芯类型：</td>
                        <td >
                            <c:choose>
                                <c:when test="${logs.logsFilterType == 1 }">
                                    T1
                                </c:when>
                                <c:when test="${logs.logsFilterType == 2 }">
                                    T2
                                </c:when>
                                <c:when test="${logs.logsFilterType == 3 }">
                                    T3
                                </c:when>
                                <c:when test="${logs.logsFilterType == 4 }">
                                    T4
                                </c:when>
                            </c:choose>
                        </td>
                        <td class="f-14" style="font-weight: bold;">设备(微信)id：</td>
                        <td>${logs.logsMachineDeviceId }</td>
                        <td class="f-14" style="font-weight: bold;">发货时间：</td>
                        <td colspan="4"><fmt:formatDate value="${logs.logsSendTime }" pattern="yyyy-MM-dd HH:mm:ss"/></td>
                    </tr>
                    <tr class="text-r">
                        <td class="f-14" style="font-weight: bold;">完成时间：</td>
                        <td colspan="6"><fmt:formatDate value="${logs.logsAccomplishTime }" pattern="yyyy-MM-dd HH:mm:ss"/></td>
                    </tr>
                </table>
            </c:if>
            <c:if test="${(empty logs)}">
                <div style="width: 100%;" class="text-c">未查询到该订单信息!</div>
            </c:if>
        </div>
    </div>
</div>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/jquery/1.9.1/jquery.min.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/Validform/5.3.2/Validform.min.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/layer/1.9.3/layer.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/icheck/jquery.icheck.min.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.admin.js"></script>
<script type="text/javascript">

    $(function(){
        $('.skin-minimal input').iCheck({
            checkboxClass: 'icheckbox-blue',
            radioClass: 'iradio-blue',
            increaseArea: '20%'
        });
        $.Huitab("#tab-system .tabBar span","#tab-system .tabCon","current","click","0");
    });

    function IntegralLogs(title, url, w, h) {
        layer_show(title,url,w,h);
    }
</script>
</body>
</html>