<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">
<meta name="renderer" content="webkit|ie-comp|ie-stand">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta name="viewport"
	content="width=device-width,initial-scale=1,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<LINK rel="Bookmark" href="/favicon.ico">
<LINK rel="Shortcut Icon" href="/favicon.ico" />
<!--[if lt IE 9]>
<script type="text/javascript" src="lib/html5.js"></script>
<script type="text/javascript" src="lib/respond.min.js"></script>
<script type="text/javascript" src="lib/PIE_IE678.js"></script>
<![endif]-->
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.min.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.admin.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/skin/default/skin.css" rel="stylesheet" type="text/css" id="skin" />
<link href="${pageContext.request.contextPath }/common/admin/lib/Hui-iconfont/1.0.1/iconfont.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/style.css" rel="stylesheet" type="text/css" />

<!--[if IE 6]>
<script type="text/javascript" src="lib/DD_belatedPNG_0.0.8a-min.js" ></script>
<script>DD_belatedPNG.fix('*');</script>
<![endif]-->
<title>产品列表</title>
</head>
<body>
	<nav class="breadcrumb">
		<i class="Hui-iconfont">&#xe67f;</i> 首页 <span class="c-gray en">&gt;</span>
		商品管理 <span class="c-gray en">&gt;</span> 商品类型列表 <a
			class="btn btn-success radius r mr-20"
			style="line-height: 1.6em; margin-top: 3px"
			href="javascript:location.replace(location.href);" title="刷新"><i
			class="Hui-iconfont">&#xe68f;</i></a>
	</nav>
	
	<div class="pd-20">
	<div class="cl pd-5 bg-1 bk-gray mt-20"> 
		<span class="l">
			<a href="${pageContext.request.contextPath }/admin/rewards/toAdd" class="btn btn-primary radius">
				<i class="Hui-iconfont">&#xe600;</i> 添加分销奖励
			</a>
		</span>
	</div>
	<form id="goodsform" >
		<table class="table table-border table-bordered table-bg" id="example">
			<thead>
				<tr>
					<th scope="col" colspan="9">奖励规则列表</th>
				</tr>
				<tr class="text-c">
					<th width="25"><input type="checkbox" name="" value=""></th>
					<th width="100">规则名称</th>
					<th width="100">规则描述</th>
					<th width="80">达标数量</th>
					<th width="80">奖励金额/每台</th>
					
					<th width="100">产品类型</th>
					<th width="130">创建时间</th>
					<th width="130">修改时间</th>
					<th width="150">操作</th>
				</tr>
			</thead>
			<tbody>
				<c:if test="${! (empty list) }">
					<c:forEach items="${list }" var="rank">
						<tr class="text-c">
							<td><input type="checkbox" value="${rank.rankId }" name="typeId"></td>
							<td>${rank.rankName }</td>
							<td>${rank.rankDesc }</td>
							<td>${rank.rankNum }</td>
							<td>${rank.rankMoney / 100}</td>
							
							<td>${rank.productType.typeName }</td>
							<td><fmt:formatDate value="${rank.rankCreateDate }" pattern="yyyy-MM-dd HH:mm:ss"/></td>
							<td><fmt:formatDate value="${rank.rankUpdateDate }" pattern="yyyy-MM-dd HH:mm:ss"/></td>
							<%-- <td class="td-manage">
								<a onclick="goods_edit('${pageContext.request.contextPath }/admin/rewards/toUpdate?rankId=${rank.rankId }')" 
								title="编辑" href="javascript:;"  class="ml-5" style="text-decoration:none"><i class="Hui-iconfont">&#xe6df;</i></a> 
							</td> --%>
							<td class="td-manage">
								<input id="through" class="btn btn-primary radius upload-btn" onclick="goods_edit('${pageContext.request.contextPath }/admin/rewards/toUpdate?rankId=${rank.rankId }')" type="button" value="修改" />&nbsp;
								<input id="through" class="btn btn-primary radius upload-btn" onclick="deleteRank(this,${rank.rankId });" type="button" value="删除" />
							</td>
					</c:forEach>
				</c:if>
			</tbody>
		</table>
		<%-- <div align="right" class="mt-10 mb-10 mr-10">
			<%@include file="/common/other/paper/pager.jsp"%>
  		</div> --%>
  		</form>
	</div>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/jquery/1.9.1/jquery.min.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/layer/1.9.3/layer.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.admin.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/tips.js"></script> 
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/My97DatePicker/WdatePicker.js"></script> 
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/datatables/1.10.0/jquery.dataTables.min.js"></script> 
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/js/page/jqPaginator.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/goods/js/utils.js"></script>
	<script type="text/javascript">
	/* $(document).ready(function(){
		$('#beginDate').datepicker();//时间控件
        $('#endDate').datepicker();
	}); */
	
	function  dataCheck(){
		 //商品名称数据验证
		 if($("#goodsInfoGoodname").val()!= ""){
			if(!commonLengthJdg('goodsInfoGoodname',1,30,null,true)){
				layer.msg("商品名称长度为1-30位",{icon: 5,time:3000});
				return false;
			}
		 }
		//最小价格格式验证
		 if($("#minMoney").val()!= ""){
			if(!commonTypeJdg('minMoney','money',null,true)){
				layer.msg("最小价格须为金钱格式",{icon: 5,time:3000});
				return false;
			}
		 }
		//最大价格格式验证
		if($("#maxMoney").val()!= ""){
			if(!commonTypeJdg('maxMoney','money',null,true)){
				layer.msg("最大价格须为金钱格式",{icon: 5,time:3000});
				return false;
			}
		}
		return true;
	}
/**
 * 打开修改商品界面
 */
function goods_edit(url){
	window.location.href = url;
}
function deleteRank(obj,id){
	//alert("-----------");
	layer.confirm('确认要删除吗？',function(){
		$.ajax({
			url: '${pageContext.request.contextPath }/admin/rewards/delete',
			data:{ "rankId":id },
			dataType:'json',//服务器返回json格式数据
			type:'post',	//HTTP请求类型
			error:function(data){
	      	  	layer.msg("删除失败!",{icon: 5,time:2000});
	        },
	        success:  function(data){
	      	  	if(data.status){
					$(obj).parents("tr").remove();
					layer.msg('已删除!',{icon:1,time:3000});
	      	  	}else{
	      	  		layer.msg(data.message,{icon:1,time:3000});
	      	  	}
	        }
		});
	});
}
</script>
</body>
</html>