<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">
<meta name="renderer" content="webkit|ie-comp|ie-stand">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta name="viewport"
	content="width=device-width,initial-scale=1,minimum-scale=1.0,maximum-

scale=1.0,user-scalable=no" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<LINK rel="Bookmark" href="/favicon.ico">
<LINK rel="Shortcut Icon" href="/favicon.ico" />
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.min.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.admin.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/skin/default/skin.css" rel="stylesheet" type="text/css" id="skin" />
<link href="${pageContext.request.contextPath }/common/admin/lib/Hui-iconfont/1.0.1/iconfont.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/style.css" rel="stylesheet" type="text/css" />
<!--[if IE 6]>
<script type="text/javascript" src="lib/DD_belatedPNG_0.0.8a-min.js" ></script>
<script>DD_belatedPNG.fix('*');</script>
<![endif]-->
<title>分享记录</title>
</head>
<body>
	<nav class="breadcrumb">
		<i class="Hui-iconfont">&#xe67f;</i> 首页 <span class="c-gray en">&gt;</span>
		分享记录 <span class="c-gray en">&gt;</span>分享记录列表 <a
			class="btn btn-success radius r mr-20"
			style="line-height: 1.6em; margin-top: 3px"
			href="javascript:location.replace(location.href);" title="刷新"><i
			class="Hui-iconfont">&#xe68f;</i></a>
	</nav>
	<div class="pd-20">
	<form action="${pageContext.request.contextPath }/admin/shareRecord/listFuzzyShareRecordUI" method="post">
			<div class="formControls col-2">
			<input name="username" id="username" value="${userId }" placeholder="分享人昵称" style="width: 300px" class="input-text" type="text">
			</div>&nbsp;&nbsp;&nbsp;&nbsp;
			<div class="formControls col-2">
			 <span class="select-box">
				<select id="shareIsStatus" name="shareIsStatus" class="select">
					<option value="" >是否奖励</option>
					<option value="1" ${shareIsStatus==1?'selected':''}>已奖励</option>
					<option value="2" ${shareIsStatus==2?'selected':''}>未奖励</option>
				</select>
			</span>
			</div>
			&nbsp;&nbsp;
			日期范围： <input  id="beginDate" value="${beginDate }" name="beginDate" class="input-text Wdate" style="width: 120px;" type="text" onfocus="WdatePicker({dateFmt:'yyyy-MM-dd',maxDate:'#F{$dp.$D(\'endDate\')||\'%y-%M-%d\'}'})" readonly>
				 - <input  id="endDate" value="${endDate }" name="endDate" class="input-text Wdate" style="width: 120px;" type="text" onfocus="WdatePicker({dateFmt:'yyyy-MM-dd',minDate:'#F{$dp.$D(\'beginDate\')||\'%y-%M-%d\'}'})" readonly>
			<button name="" id="submitBtn" onclick="return dataValidation();" class="btn btn-success" type="submit">
				<i class="Hui-iconfont"></i> 搜索
			</button>
		</form>
	<form id="adminlist" >
		<table class="table table-border table-bordered table-bg">
			<thead>
				<tr>
					<th scope="col" colspan="9">分享记录列表</th>
				</tr>
				<tr class="text-c">
					<th width="150">推广人</th>
					<th width="150">推广类型</th>
					<th width="90">推广页面</th>
					<th width="150">推广时间</th>
					<th width="130">是否奖励</th>
					<th width="100">奖励数量</th>
				</tr>
			</thead>
			<tbody>
				<c:if test="${! (empty shareRecordinfoList) }">
					<c:forEach items="${shareRecordinfoList }" var="infolist">
						<tr class="text-c">
							<td>${infolist.userName }</td>
							<td>${infolist.shareType }</td>
							<td>${infolist.sharePage }</td>
							<td><fmt:formatDate value="${infolist.shareDate }" pattern="yyyy-MM-dd"/></td>
							<td>${infolist.shareIsStatus==1?'<font color=green >已奖励</font>':''}${infolist.shareIsStatus==2?'<font color=yellow >未奖励</font>':''}</td>
							<td>${infolist.sgareNum }</td>
					</c:forEach>
				</c:if>
			</tbody>
		</table>
		<div align="right" class="mt-10 mb-10 mr-10">
			<%@include file="/common/other/paper/pager.jsp"%>
  		</div>
  		</form>
	</div>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/jquery/1.9.1/jquery.min.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/layer/1.9.3/layer.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.admin.js"></script>
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/tips.js"></script> 
	<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/My97DatePicker/WdatePicker.js"></script> 
	<script type="text/javascript">
	/* function dataValidation(){
		if($("#username").val()!=null){
			 //推广人姓名数据验证
			if(!commonLengthJdg('username',1,30,null,true)){
				layer.msg("推广人昵称长度为1-30位",{icon: 2,time:2000});
				return false;
			}
		}
	} */
</script>
</body>
</html>